{% from "bootstrap5/form.html" import quick_form, render_field %}
{% extends "base.html" %}
{% block title %}IBERT{% endblock %}
{% block content %}

<div class="container">
<h2>IBERT test</h2>


<!-- IBERT test results -->
<table class="table">
  <thead>
    <tr>
      <th scope="col">Link</th>
      <th scope="col">TX</th>
      <th scope="col">RX</th>
      <th scope="col">Loopback mode</th>
      <th scope="col">Status</th>
      <th scope="col">Errors</th>
      <th scope="col">BER</th>
      <th scope="col">TX Pattern</th>
      <th scope="col">RX Pattern</th>
      <th scope="col">TX Pre-cursor</th>
      <th scope="col">TX Post-cursor</th>
      <th scope="col">TX Diff. Swing</th>
      <th scope="col">Termination voltage</th>
    </tr>
  </thead>
  <tbody>

{% for link_name, data in ibert.items() %}
	<tr>
        <th scope="row">{{ link_name }}</th>
        <td>{{ data["TX_ENDPOINT"] }}</td>
        <td>{{ data["RX_ENDPOINT"] }}</td>
        <td>{{ data["LOOPBACK"] }}</td>
        <td>{{ data["RX_STATUS"] }}</td>
        <td>{{ data["RX_PRBS_ERR_CNT"] }}</td>
        <td>{{ "{:.2e}".format(data["RX_PRBS_BER"] | float) }}</td>
        <td>{{ data["TX_PATTERN"] }}</td>
        <td>{{ data["RX_PATTERN"] }}</td>
        <td>{{ data["TX_PRE_CURSOR"] }}</td>
        <td>{{ data["TX_POST_CURSOR"] }}</td>
        <td>{{ data["TX_DIFF_CTRL"] }}</td>
        <td>{{ data["RX_TERMINATION_VOLTAGE"] }}</td>
    </tr>
{% endfor %}

  </tbody>
</table>


<!-- TX, RX IBERT reset buttons -->

<div class="row">
  <div class="col-auto g-2">
    <form class="form" action="/ibert/tx_reset" method="post" role="form">
      <input class="btn btn-primary" id="submit" name="submit" type="submit" value="Reset TX">
    </form>
  </div>

  <div class="col-auto g-2">
    <form class="form" action="/ibert/rx_reset" method="post" role="form">
      <input class="btn btn-primary" id="submit" name="submit" type="submit" value="Reset RX">
    </form>
  </div>

  <div class="col-auto g-2">
    <form class="form" action="/ibert/ibert_reset" method="post" role="form">
      <input class="btn btn-primary" id="submit" name="submit" type="submit" value="Reset IBERT">
    </form>
  </div>  
</div>

<!-- 
<form method="post" action="/ibert/preset" class="mb-4" role=form>
  {{ form.hidden_tag() }}
  <div class="row">
    <div class="col-auto g-2">
      {{ render_field(form.scan_preset) }}
    </div>

    <div class="col-auto g-4">
      <button class="btn btn-primary" type="submit">Apply preset</button>
    </div>
  </div>
</form> -->

</div>



<!-- Eye scan form -->
<div class="container px-0 py-4">
  <h2>Start eye scan</h2>

	<form method="post" action="/ibert/run_scan" class="mb-4" role=form>
		{{ form.hidden_tag() }}
		
		<div class="row">
			<div class="col-auto g-2">
				{{ render_field(form.scan_preset) }}
			</div>
			<div class="col-auto g-3">
				<button class="btn btn-lg btn-success" type="submit">Run eye scan</button>
			</div>
		</div>		
	</form>
</div>

<!-- Eye scan images -->
{% for scan_name, scan in scans.items() %}

<div class="container px-0 py-4">
  <h2>{{scan["comment"]}}</h2>

{% for link_name, scan_data in scan["links"].items() %}

{% if not loop.index is divisibleby 2 %}
  <div class="row">
{% endif %}

    <div class="col-auto g-2">
      <h3>{{link_name}}</h3>
      <img src="/ibert_eye_scan/{{scan_name}}/{{link_name}}.png?timestamp={{timestamp}}" alt="Scan {{scan_name}} link {{link_name}}"> 
    </div>

{% if loop.index is divisibleby 2 %}
  </div>
{% endif %}

{% endfor %}

{% endfor %}
</div>

{% endblock %}